//FM Radio OLED Copyright by GhostLion v1.3
#include <EEPROM.h>
#include <radio.h>
#include <RDA5807M.h>
#include "U8glib.h"
#include "rus6x10.h"
#include "rus10x20.h"

#define Pin_DOWN 4   // левая кнопка 
#define Pin_UP 2     // правая кнопка 
#define Pin_SET 3    // центральная кнопка 
#define FIX_BAND 1

const unsigned char Bat1 [] = { 
0x7F, 0xFC, 0x80, 0x02, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat2 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xA0, 0x01, 0xA0, 0x01, 0xA0, 0x01, 0xA0, 0x01, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat3 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xA8, 0x01, 0xA8, 0x01, 0xA8, 0x01, 0xA8, 0x01, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat4 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xAA, 0x01, 0xAA, 0x01, 0xAA, 0x01, 0xAA, 0x01, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat5 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xAA, 0x81, 0xAA, 0x81, 0xAA, 0x81, 0xAA, 0x81, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat6 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xAA, 0xA1, 0xAA, 0xA1, 0xAA, 0xA1, 0xAA, 0xA1, 0x80, 0x02, 0x7F, 0xFC};
const unsigned char Bat7 [] = {
0x7F, 0xFC, 0x80, 0x02, 0xAA, 0xA9, 0xAA, 0xAD, 0xAA, 0xAD, 0xAA, 0xA9, 0x80, 0x02, 0x7F, 0xFC};

byte v,v2,k,k2,m,m2,flag1=1,flag2=0,flag3=0;
int Voltage,s,s2;
boolean b,b2,ms,ms2,flag=1,MODE=1;
long TimeOut;

U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE|U8G_I2C_OPT_DEV_0);
RDA5807M radio; 

void setup()
{
pinMode(Pin_DOWN,INPUT_PULLUP);
pinMode(Pin_UP,INPUT_PULLUP);
pinMode(Pin_SET,INPUT_PULLUP); 

Inicial();
}

void loop()
{
Parsing();
Menu();
Energy();  
}
//==============================================
void Inicial()
{
 u8g.firstPage();  
do {
  u8g.setFont(rus10x20);
  u8g.setPrintPos(25,14);
  u8g.print(F("ФМ РАДИО"));
  u8g.setFont(rus6x10);
  u8g.setPrintPos(36,28);u8g.print(F("v 1.3 Rus"));
  u8g.setPrintPos(40,40);u8g.print(F("03.11.18"));
  u8g.setPrintPos(25,52);u8g.print(F("By GhostLion"));
  u8g.setPrintPos(40,62);u8g.print(F("STANDART"));  
   }
while( u8g.nextPage() );
delay(3000);
v  = EEPROM[1];
k  = EEPROM[2];
m  = EEPROM[3];
b  = EEPROM[4];
ms = EEPROM[5];
s  = EEPROM[6]*100+EEPROM[7];
v2=v; k2=k; m2=m; b2=b; ms2=ms; s2=s;
radio.init();
radio.setBandFrequency(FIX_BAND, s);
radio.setVolume(v);
radio.setMono(ms);
radio.setMute(false);
radio.setBassBoost(b);  
readVcc();
}
//================================================
void Parsing()
{
boolean SET=digitalRead(Pin_SET);
boolean UP=digitalRead(Pin_UP);
boolean DOWN=digitalRead(Pin_DOWN);

if(SET==HIGH && flag1==0)
  {
    flag1=1;
  }
if(SET==LOW && flag1==1)
  {
    flag1=0;
    TimeOut=millis();
    if(MODE==1) {m++; if(m>5) m=1; flag=1;}
  }
  
 if(UP==LOW && flag2==1)
  {
    flag2=0;
  }
   if(UP==HIGH && flag2==0)
   {
    if(MODE==1)
    {
    switch(m)
      {
        case 1:{ (v==15?0:v++); radio.setVolume(v); break; }
        case 2:{ b = !b; radio.setBassBoost(b); radio.setBandFrequency(FIX_BAND,s); break; }
        case 3:{ radio.seekUp(true); delay(4000); s = radio.getFrequency(); radio.setBandFrequency(FIX_BAND,s); break; }
        case 4:{ s=s+10; if (s > 10800) s = 8700; radio.setBandFrequency(FIX_BAND,s); break; }
        case 5:{ k++; if (k>23) k=1; Frequency(); radio.setBandFrequency(FIX_BAND,s);break;}
      }
   flag=1;
   TimeOut=millis();
    }
   else {(v==15?0:v++);radio.setVolume(v);}
   flag2=1;
   }
   if(DOWN==LOW && flag3==1)
  {
    flag3=0;
  }
   if(DOWN==HIGH && flag3==0)
   {
    if(MODE==1)
    {
    switch(m)
      {
        case 1:{ (v==0?15:v--); radio.setVolume(v); break; }
        case 2:{ ms = !ms; radio.setMono(ms); radio.setBandFrequency(FIX_BAND,s); break; }
        case 3:{ radio.seekDown(true); delay(4000); s=radio.getFrequency(); radio.setBandFrequency(FIX_BAND,s); break; }
        case 4:{ s=s-10; if (s<8700) s=10800; radio.setBandFrequency(FIX_BAND,s); break; }
        case 5:{ k--; if (k<1) k=23; Frequency(); radio.setBandFrequency(FIX_BAND,s);break;}
      }
   flag=1;
   TimeOut=millis();
   }
   else {(v==0?15:v--);radio.setVolume(v);}
   flag3=1;
  }
}
//================================================
void Menu()
{
float ch;
if(flag==1 && MODE==1)
{
ch=float(s)/100; 
u8g.firstPage();  
do {
u8g.setFont(rus6x10);
u8g.setDefaultForegroundColor();
u8g.setPrintPos(40,10);u8g.print(F("ФМ РАДИО"));
u8g.setPrintPos(8,23);u8g.print(F("Громкость:"));u8g.setPrintPos(85,23);u8g.print(v);
u8g.setPrintPos(8,33);u8g.print(F("Стерео/Басс:"));u8g.setPrintPos(85,33);
if(b==1){if(ms==0)u8g.print(F("ДА/ДА")); else u8g.print(F("НЕТ/ДА"));}
if(b==0){if(ms==0)u8g.print(F("ДА/НЕТ")); else u8g.print(F("НЕТ/НЕТ"));}
u8g.setPrintPos(8,43);u8g.print(F("Автопоиск:"));u8g.setPrintPos(85,43);u8g.print(F("<.>"));
u8g.setPrintPos(8,53);u8g.print(F("Частота:"));u8g.setPrintPos(85,53);u8g.print(ch,1);
u8g.setPrintPos(8,63);Kanal();
int x = 10*m;
u8g.drawTriangle(0,13+x,0,5+x,4,9+x);

if(Voltage>85) u8g.drawBitmap (0, 0, 2, 8, Bat7);
  else if(Voltage>70) u8g.drawBitmap (0, 0, 2, 8, Bat6);
  else if(Voltage>55) u8g.drawBitmap (0, 0, 2, 8, Bat5);
  else if(Voltage>40) u8g.drawBitmap (0, 0, 2, 8, Bat4);
  else if(Voltage>25) u8g.drawBitmap (0, 0, 2, 8, Bat3);
  else if(Voltage>10) u8g.drawBitmap (0, 0, 2, 8, Bat2);
  else u8g.drawBitmap (0, 0, 2, 8, Bat1);
}
while( u8g.nextPage() );     
flag=0;    
}
}
//================================================
void Kanal()
{
  switch (s)
  {
    case 8750 : k=1;break;
    case 9240 : k=2;break;
    case 9370 : k=3;break;
    case 9410 : k=4;break;
    case 9620 : k=5;break;
    case 9740 : k=6;break;
    case 9800 : k=7;break;
    case 9840 : k=8;break;
    case 9890 : k=9;break;
    case 9950 : k=10;break;
    case 10040: k=11;break;
    case 10120: k=12;break;
    case 10170: k=13;break;
    case 10210: k=14;break;
    case 10250: k=15;break;
    case 10290: k=16;break;
    case 10370: k=17;break;
    case 10460: k=18;break;
    case 10510: k=19;break;
    case 10570: k=20;break;
    case 10620: k=21;break;
    case 10710: k=22;break;
    case 10790: k=23;break;
    default: k=0;
    
  }
  switch(k)
  {
    case 0 :{u8g.print(F("Нет Данных..."));break;}
    case 1 :{u8g.print(F("Релакс ФМ"));break;}
    case 2 :{u8g.print(F("Радио Минск"));break;}
    case 3 :{u8g.print(F("Юмор ФМ"));break;}
    case 4 :{u8g.print(F("Легенды ФМ"));break;}
    case 5 :{u8g.print(F("Мелодии Века"));break;}
    case 6 :{u8g.print(F("Минская Волна"));break;}
    case 7 :{u8g.print(F("АвтоРадио"));break;}
    case 8 :{u8g.print(F("Новое Радио"));break;}
    case 9 :{u8g.print(F("Русское Радио"));break;}
    case 10 :{u8g.print(F("Радио Юнистар"));break;}
    case 11 :{u8g.print(F("Радио Хит"));break;}
    case 12 :{u8g.print(F("Пилот ФМ"));break;}
    case 13 :{u8g.print(F("Радио ОНТ"));break;}
    case 14 :{u8g.print(F("Радио Рокс"));break;}
    case 15 :{u8g.print(F("Народное Радио"));break;}
    case 16 :{u8g.print(F("Радио Культура"));break;}
    case 17 :{u8g.print(F("Радиус ФМ"));break;}
    case 18 :{u8g.print(F("Радио Би-Эй"));break;}
    case 19 :{u8g.print(F("Радио Столица"));break;}
    case 20 :{u8g.print(F("Душевное Радио"));break;}
    case 21 :{u8g.print(F("Первый Канал"));break;}
    case 22 :{u8g.print(F("Радио Мир"));break;}
    case 23 :{u8g.print(F("Альфа Радио"));break;}
   }
}
//========================================================
void Frequency()
{
 switch(k)
  {
    case 1 :{s=8750;break;}
    case 2 :{s=9370;break;}
    case 3 :{s=8750;break;}
    case 4 :{s=9410;break;}
    case 5 :{s=9620;break;}
    case 6 :{s=9740;break;}
    case 7 :{s=9800;break;}
    case 8 :{s=9840;break;}
    case 9 :{s=9890;break;}
    case 10 :{s=9950;break;}
    case 11 :{s=10040;break;}
    case 12 :{s=10120;break;}
    case 13 :{s=10170;break;}
    case 14 :{s=10210;break;}
    case 15 :{s=10250;break;}
    case 16 :{s=10290;break;}
    case 17 :{s=10370;break;}
    case 18 :{s=10460;break;}
    case 19 :{s=10510;break;}
    case 20 :{s=10570;break;}
    case 21 :{s=10620;break;}
    case 22 :{s=10710;break;}
    case 23 :{s=10790;break;}
  } 
}
//=======================================================
void Energy()
{
 if(MODE==1 && millis()-TimeOut>8000)
  {
    u8g.sleepOn(); 
    MODE=0;
    if(v2!=v){v2=v; EEPROM[1] = v;}
    if(k2!=k){k2=k; EEPROM[2] = k;}
    if(m2!=m){m2=m; EEPROM[3] = m;}
    if(b2!=b){b2=b; EEPROM[4] = b;}
    if(ms2!=ms){ms2=ms; EEPROM[5] = ms;}
    if(s2!=s){s2=s; EEPROM[6] = int(s/100); EEPROM[7] = s%100;}
  }
  if(MODE==0 && millis()-TimeOut<500)
  {
    u8g.sleepOff(); 
    readVcc();
    MODE=1;flag=1; 
  }
}
//===================================================
void readVcc() 
{
#if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
  ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
#else
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
#endif
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA, ADSC)); // measuring
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH
  uint8_t high = ADCH; // unlocks both
  long result = (high << 8) | low;

  result = 1.080 * 1023 * 1000 / result; // расчёт реального VCC
  Voltage = int(result);
  Voltage = map(Voltage, 3200, 4200, 0, 100);
  Voltage = constrain(Voltage, 0, 100);
}
